/*
 * This file generated automatically from xdrm.xml by c_client.py.
 * Edit at your peril.
 */

/**
 * @defgroup XCB_XDRM_API XCB XDRM API
 * @brief XDRM XCB Protocol Implementation.
 * @{
 **/

#ifndef __XDRM_H
#define __XDRM_H

#include "xcb.h"
#include "xproto.h"

#ifdef __cplusplus
extern "C" {
#endif

#define XCB_XDRM_MAJOR_VERSION 1
#define XCB_XDRM_MINOR_VERSION 0

extern xcb_extension_t xcb_xdrm_id;

/**
 * @brief xcb_xdrm_query_version_cookie_t
 **/
typedef struct xcb_xdrm_query_version_cookie_t {
    unsigned int sequence;
} xcb_xdrm_query_version_cookie_t;

/** Opcode for xcb_xdrm_query_version. */
#define XCB_XDRM_QUERY_VERSION 0

/**
 * @brief xcb_xdrm_query_version_request_t
 **/
typedef struct xcb_xdrm_query_version_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    uint32_t major_version;
    uint32_t minor_version;
} xcb_xdrm_query_version_request_t;

/**
 * @brief xcb_xdrm_query_version_reply_t
 **/
typedef struct xcb_xdrm_query_version_reply_t {
    uint8_t  response_type;
    uint8_t  pad0;
    uint16_t sequence;
    uint32_t length;
    uint32_t major_version;
    uint32_t minor_version;
} xcb_xdrm_query_version_reply_t;

/** Opcode for xcb_xdrm_add_authorized_app_for_capture. */
#define XCB_XDRM_ADD_AUTHORIZED_APP_FOR_CAPTURE 1

/**
 * @brief xcb_xdrm_add_authorized_app_for_capture_request_t
 **/
typedef struct xcb_xdrm_add_authorized_app_for_capture_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    uint32_t fileSize;
} xcb_xdrm_add_authorized_app_for_capture_request_t;

/** Opcode for xcb_xdrm_remove_authorized_app_for_capture. */
#define XCB_XDRM_REMOVE_AUTHORIZED_APP_FOR_CAPTURE 1

/**
 * @brief xcb_xdrm_remove_authorized_app_for_capture_request_t
 **/
typedef struct xcb_xdrm_remove_authorized_app_for_capture_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    uint32_t fileSize;
} xcb_xdrm_remove_authorized_app_for_capture_request_t;

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_xdrm_query_version_cookie_t
xcb_xdrm_query_version (xcb_connection_t *c,
                        uint32_t          major_version,
                        uint32_t          minor_version);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */
xcb_xdrm_query_version_cookie_t
xcb_xdrm_query_version_unchecked (xcb_connection_t *c,
                                  uint32_t          major_version,
                                  uint32_t          minor_version);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 *
 * The parameter @p e supplied to this function must be NULL if
 * xcb_xdrm_query_version_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */
xcb_xdrm_query_version_reply_t *
xcb_xdrm_query_version_reply (xcb_connection_t                 *c,
                              xcb_xdrm_query_version_cookie_t   cookie  /**< */,
                              xcb_generic_error_t             **e);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */
xcb_void_cookie_t
xcb_xdrm_add_authorized_app_for_capture_checked (xcb_connection_t *c,
                                                 uint32_t          fileSize,
                                                 int32_t           app_id_fd);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_void_cookie_t
xcb_xdrm_add_authorized_app_for_capture (xcb_connection_t *c,
                                         uint32_t          fileSize,
                                         int32_t           app_id_fd);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */
xcb_void_cookie_t
xcb_xdrm_remove_authorized_app_for_capture_checked (xcb_connection_t *c,
                                                    uint32_t          fileSize,
                                                    int32_t           app_id_fd);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_void_cookie_t
xcb_xdrm_remove_authorized_app_for_capture (xcb_connection_t *c,
                                            uint32_t          fileSize,
                                            int32_t           app_id_fd);


#ifdef __cplusplus
}
#endif

#endif

/**
 * @}
 */
